//+------------------------------------------------------------------+
//|                                                  KDE_Example.mq5 |
//|                                                    2012, victorg |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "2012, victorg"
#property link      "http://www.mql5.com"
#property strict

#include <CKDensity.mqh>
//#include <ChartTools\CLinDraw.mqh>

int d;   // File handle

double X[];
double Sc[];
double Z[];
  
void OnInit()
  {
   int i;
   int ndata=20;                       // Input data length
  
   d=FileOpen("density_test",FILE_CSV|FILE_WRITE);

  //-------------------------- Preparation of the input sequence
  ArrayResize(X,ndata+1);
  /* i=CopyOpen(_Symbol,PERIOD_CURRENT,0,ndata+1,X);
   if(i!=ndata+1)
     {
      Print("Not enough historical data.");
      return;
     }
   for(i=0;i<ndata;i++)X[i]=MathLog(X[i+1]/X[i]); // Logarithmic returns
   
   */
   
   X[0]=0.30;X[1]=0.30;X[2]=0.31;X[3]=0.32;X[4]=0.30;X[5]=0.29;X[6]=0.40;X[7]=0.50;
   X[8]=0.70;X[9]=0.71;X[10]=0.70;X[11]=0.70;X[12]=0.68;X[13]=0.71;X[14]=0.72;X[15]=0.90;
   X[16]=0.91;X[17]=0.90;X[18]=1.10;X[19]=1.30;
   
   ArrayResize(X,ndata);

//-------------------------- Kernel density estimation
   CKDensity *kd=new CKDensity;
   kd.PluginMode(1);                     // Enable Plug-in mode
   kd.Density(X);                        // Density estimation 

//-------------------------- Graph of a Laplace distribution
/*
   n=kd.Np;                              // Number of test point
   ArrayResize(Z,n);
   for(i=0;i<n;i++)
     {
      a=MathAbs(kd.T[i]*M_SQRT2);
      Z[i]=0.5*MathExp(-a)*M_SQRT2;
     }
//-------------------------- Scatter plot
   n=kd.N;                               // Data length
   if(n<400)
     {
      ArrayResize(Sc,n);
      for(i=0;i<n;i++)Sc[i]=kd.X[i];
     }
   else                                  // Decimation of data
     {
      ArrayResize(Sc,400);
      for(i=0;i<400;i++)
        {
         a=i*(n-1.0)/399.0+0.5;
         Sc[i]=kd.X[(int)a];
        }
     }
*/
//-------------------------- Visualization
 /*  CLinDraw *ld=new CLinDraw;
   ld.Title("Kernel Density Estimation");
   ld.SubTitle(StringFormat("Data lenght=%i, h=%.3f",kd.N,kd.H));
   ld.YTitle("density");
   ld.XTitle("normalized X (mean=0, variance=1)");

   ld.AddGraph(kd.T,Z,"line","Laplace",1,"200,120,70,1");
   ld.AddGraph(kd.T,kd.Y,"line","Estimation");
   ld.AddGraph(Sc,-0.02,"scatter","Data",0,"0,4,16,0.4");

   ld.LDraw();                           // With WEB-browser autostart 
                                        //   ld.LDraw(0);                        // Without autostart 
   //  delete(ld);
*/
   int tt=ArraySize(kd.Y);
   
   for(i=0;i<tt;i++) FileWrite(d,DoubleToStr(X[i],5)+"&"+DoubleToStr(kd.T[i],5)+"&"+DoubleToStr(kd.Y[i],5));
 



   delete(kd);
  }
//--------------------------------------------------------------------


void OnDeinit(const int xreason)
{
   FileFlush(d);
   FileClose(d);
}
